﻿using MyUserControls.Components.office_package;
using MyUserControls.Components.office_package.HelperEnums;
using MyUserControls.Components.office_package.HelperModels;
using MyUserControls.Components.office_package.Implements;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace MyUserControls.Components.PdfImage
{
    public partial class PdfImage : Component
    {
        ISaveToPdf SaveToPdf = new SaveToPdf();

        public PdfImage()
        {
            InitializeComponent();
        }

        public PdfImage(IContainer container)
        {
            container.Add(this);
            InitializeComponent();
        }

        public void CreatePdf(PdfImageInfo info)
        {
            info.CheckFields();
            SaveToPdf.CreatePdf(info);
            SaveToPdf.CreateParagraph(new PdfParagraph
            {
                Text = info.Title,
                Style = "NormalTitle",
                ParagraphAlignment = PdfParagraphAlignmentType.Center
            });
            foreach (var image in info.Images)
            {
                SaveToPdf.CreateImage(image);
            }
            SaveToPdf.SavePdf(info);
        }
    }
}
