﻿using MyUserControls.Components.office_package.HelperModels;
using MyUserControls.Components.PdfImage;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace MyUserControls.Components.office_package
{
    public interface ISaveToPdf
    {
        /// <summary>
        /// Создание doc-файла
        /// </summary>
        /// <param name="info"></param>
        void CreatePdf(IPdfInfo info);
        /// <summary>
        /// Создание параграфа с текстом
        /// </summary>
        void CreateParagraph(PdfParagraph paragraph);
        /// <summary>
        /// Создание изображения в pdf файле
        /// </summary>
        void CreateImage(byte[] image);
        /// <summary>
        /// Создание таблицы
        /// определенной ширины
        /// </summary>
        void CreateTable();
        /// <summary>
        /// Создание таблицы с заданным количеством столбцов
        /// определенной ширины
        /// </summary>
        void CreateTableWithColumns(List<string> columns);
        /// <summary>
        /// Создание таблицы с заданным количеством столбцов
        /// </summary>
        void CreateTableWithColumns(int columnNumber);
        /// <summary>
        /// Создание и заполнение строки
        /// </summary>
        /// <param name="rowParameters"></param>
        void CreateRow(PdfRowParameters rowParameters);
        /// <summary>
        /// Создание и заполнение столбца
        /// </summary>
        void InsertTextIntoColumn(PdfColumnParameters columnParameters);
        /// <summary>
        /// Создание и заполнение ячейки
        /// </summary>
        void InsertTextIntoCell(int rowIndex, int columnIndex, PdfCellParameters cellParameters);
        /// <summary>
        /// Создание и заполнение ячейки
        /// </summary>
        void MergeCells(PdfCellsMergeParameters parameters);
        /// <summary>
        /// Создание и заполнение круговой диаграммы
        /// </summary>
        void CreatePieChart(IPdfPieChartParameters parameters);
        /// <summary>
        /// Сохранение файла
        /// </summary>
        void SavePdf(IPdfInfo info);
    }
}
